#include <vlib.h>


// This is a table of all colors used by all buttons
ButtonColors buttoncolors = {
    0x00b0b000, 0x00808080, 0x00d0d0d0, 0x00404040,
    0x00f0f0f0, 0x00808080, 0x00d0d0d0, 0x00404040,
    0x00b0b000, 0x00585858, 0x00d0d0d0, 0x00404040,
    0x00606060
};


// This is where the offsets for the above colors will be
ButtonClrMap buttonoffsets;




// Text to place in buttons
UBYTE quittext[] = "Quit";
UBYTE toggtext[] = "Toggle";
UBYTE othrtext[] = "Other";



Button quit = {

    480, 32, 96, 24, 0, 0,
    &buttoncolors, &buttonoffsets,
    0, BUTTON_ACTION_POPUP, BUTTON_STYLE_OVAL | BUTTON_STYLE_OUTLINE,
    BUTTON_TYPE_BOOLEAN, 0, 0, 0xaaff, quittext, 0, 0, 0
};

Button toggle = {

    16, 32, 92, 24, 0, 0,
    &buttoncolors, &buttonoffsets,
    0, BUTTON_ACTION_TOGGLE | BUTTON_ACTION_HITONRELEASE,
    BUTTON_STYLE_ROUND | BUTTON_STYLE_OUTLINE | BUTTON_STYLE_BORDERHI,
    BUTTON_TYPE_BOOLEAN, 3, 2, 0x0001, toggtext, 0, 0, 0
};

Button toggle2 = {

    124, 32, 92, 24, 0, 0,
    &buttoncolors, &buttonoffsets,
    0, BUTTON_ACTION_TOGGLE | BUTTON_ACTION_HITONRELEASE,
    BUTTON_STYLE_OVAL | BUTTON_STYLE_OUTLINE | BUTTON_STYLE_BORDERLO,
    BUTTON_TYPE_BOOLEAN, 3, 2, 0x0002, toggtext, 0, 0, 0
};

Button toggle3 = {

    240, 32, 92, 24, 0, 0,
    &buttoncolors, &buttonoffsets,
    0, BUTTON_ACTION_TOGGLE | BUTTON_ACTION_HITONRELEASE,
    BUTTON_STYLE_SMOOTH | BUTTON_STYLE_OUTLINE | BUTTON_STYLE_BORDERLO | BUTTON_STYLE_BORDERHI,
    BUTTON_TYPE_BOOLEAN, 5, 3, 0x0003, toggtext, 0, 0, 0
};

Button other = {

    364, 32, 92, 24, 0, 0,
    &buttoncolors, &buttonoffsets,
    0, BUTTON_ACTION_TOGGLE, BUTTON_STYLE_SMOOTH,
    BUTTON_TYPE_BOOLEAN, 0, 0, 0x0004, othrtext, 0, 0, 0
};


Slider sliderdata = {
    5, 0, 3864, 0, 64
};


Button spriteslider = {

    64, 96, 512, 14, 0, 0,
    &buttoncolors, &buttonoffsets,
    0, 0, BUTTON_STYLE_OVAL | BUTTON_STYLE_OUTLINE, BUTTON_TYPE_SLIDER,
    0, 0, 0x0100, 0, 0, 0, &sliderdata
};





void main(void)
{
WORD mousespr;
Button *hit_button = NULL, *sliderbutton;

    // Initialize most resources and setup screen/sprite stuff
    InitVLib(INIT_MOST);

    // Create a sprite out of the built in mouse pointer data
    mousespr = AddSprite(mouseptr.width, mouseptr.height, mouseptrdata, 0);

    // Clear the screen with color 0x606060
    ScreenFill(FindColor(colormap, 0x00606060));

    // Add the buttons
    AddButton(&quit);
    AddButton(&toggle3);
    AddButton(&toggle2);
    AddButton(&toggle);
    AddButton(&other);
    sliderbutton = AddButton(&spriteslider);

    DoSliderText(sliderbutton);

    // Loop until quit button is hit
    while(hit_button->id != 0xaaff) {

        // Check to see what button was hit
        hit_button = CheckButtons();

        // Print text if it was the slider
        if(hit_button->type & BUTTON_TYPE_SLIDER)
            DoSliderText(hit_button);

        // Move the mouse and call DoubleBuffer
        UpdateMouse(mousespr);

    }

    // Remove the buttons
    RemoveButton(0x0100);
    RemoveButton(0x0001);
    RemoveButton(0x0002);
    RemoveButton(0x0003);
    RemoveButton(0x0004);
    RemoveButton(0xaaff);

    // Free resources and exit program
    FreeVLib();
}


void DoSliderText(Button *slider)
{
static UBYTE text[16];

    DrawFilledBox(64, 85, 196, 94, FindColor(colormap, 0x00606060));
    sprintf(text, "%d of %d", slider->slider->currentry,
            slider->slider->maxentries - 1);
    Text(64, 85, text, FindColor(colormap, 0x00909090));
}